(ns clojure-x86-interpreter.core-test
  (:require [clojure.test :refer :all]
            [clojure-x86-interpreter.core :refer :all]
            [clojure-x86-interpreter.memory-instructions :refer :all]
            [clojure-x86-interpreter.program-state :refer :all]
            [clojure-x86-interpreter.utils :refer :all]))

;(println (dec-to-bin 443))
;(println (appendBitVector (appendBitVector (vector) 23) 1))
;(println (update-in default-program-state [:code] list "mov 123 RAX"))
;(println (extract-bits 171 5 2))
(defn testregs []
  (println "\n64:")
  (println (pr-str (get-bit-width "rax")))
  (println (pr-str (get-bit-width "rbx")))
  (println (pr-str (get-bit-width "rcx")))
  (println (pr-str (get-bit-width "rdx")))
  (println (pr-str (get-bit-width "rsi")))
  (println (pr-str (get-bit-width "rdi")))
  (println (pr-str (get-bit-width "rbp")))
  (println (pr-str (get-bit-width "rsp")))
  (println (pr-str (get-bit-width "r8")))
  (println (pr-str (get-bit-width "r9")))
  (println (pr-str (get-bit-width "r10")))
  (println (pr-str (get-bit-width "r11")))
  (println (pr-str (get-bit-width "r12")))
  (println (pr-str (get-bit-width "r13")))
  (println (pr-str (get-bit-width "r14")))
  (println (pr-str (get-bit-width "r15")))

  (println "\n32:")
  (println (pr-str (get-bit-width "eax")))
  (println (pr-str (get-bit-width "ebx")))
  (println (pr-str (get-bit-width "ecx")))
  (println (pr-str (get-bit-width "edx")))
  (println (pr-str (get-bit-width "esi")))
  (println (pr-str (get-bit-width "edi")))
  (println (pr-str (get-bit-width "ebp")))
  (println (pr-str (get-bit-width "esp")))
  (println (pr-str (get-bit-width "r8d")))
  (println (pr-str (get-bit-width "r9d")))
  (println (pr-str (get-bit-width "r10d")))
  (println (pr-str (get-bit-width "r11d")))
  (println (pr-str (get-bit-width "r12d")))
  (println (pr-str (get-bit-width "r13d")))
  (println (pr-str (get-bit-width "r14d")))
  (println (pr-str (get-bit-width "r15d")))

  (println "\n16:")
  (println (pr-str (get-bit-width "ax")))
  (println (pr-str (get-bit-width "bx")))
  (println (pr-str (get-bit-width "cx")))
  (println (pr-str (get-bit-width "dx")))
  (println (pr-str (get-bit-width "si")))
  (println (pr-str (get-bit-width "di")))
  (println (pr-str (get-bit-width "bp")))
  (println (pr-str (get-bit-width "sp")))
  (println (pr-str (get-bit-width "r8w")))
  (println (pr-str (get-bit-width "r9w")))
  (println (pr-str (get-bit-width "r10w")))
  (println (pr-str (get-bit-width "r11w")))
  (println (pr-str (get-bit-width "r12w")))
  (println (pr-str (get-bit-width "r13w")))
  (println (pr-str (get-bit-width "r14w")))
  (println (pr-str (get-bit-width "r15w")))

  (println "\n8:")
  (println (pr-str (get-bit-width "al")))
  (println (pr-str (get-bit-width "bl")))
  (println (pr-str (get-bit-width "cl")))
  (println (pr-str (get-bit-width "dl")))
  (println (pr-str (get-bit-width "sil")))
  (println (pr-str (get-bit-width "dil")))
  (println (pr-str (get-bit-width "bpl")))
  (println (pr-str (get-bit-width "spl")))
  (println (pr-str (get-bit-width "r8b")))
  (println (pr-str (get-bit-width "r9b")))
  (println (pr-str (get-bit-width "r10b")))
  (println (pr-str (get-bit-width "r11b")))
  (println (pr-str (get-bit-width "r12b")))
  (println (pr-str (get-bit-width "r13b")))
  (println (pr-str (get-bit-width "r14b")))
  (println (pr-str (get-bit-width "r15b")))

  (println "\n8:")
  (println (pr-str (get-bit-width "ah")))
  (println (pr-str (get-bit-width "bh")))
  (println (pr-str (get-bit-width "ch")))
  (println (pr-str (get-bit-width "dh"))))

(testregs)

(read-memory 1)